﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Security.Cryptography.X509Certificates;
using System.Net.Security;

namespace FileConverterPro {
    public partial class MainForm : Form {
        internal void SaveLocalPath(string file) {
#if LOCAL_PATH
            try {
                string localPath = @"c:\temp\FCpro";
                localPath = System.IO.Path.Combine(localPath,
                    System.IO.Path.GetFileName(file));
                System.IO.File.Copy(file, localPath, true);
            }
            catch {
            }
#endif
        }

        internal static FileConverterProWebServiceSample.ServiceReference1.FileConverterProService2Client client = null;
        internal static FileConverterProWebServiceSample.ServiceReference2.FileConverterProAdmin2Client admin = null;

        private List<string> jobIDs = new List<string>();

        private string originalTitle = "";
        public MainForm() {
            InitializeComponent();



            System.Net.ServicePointManager.ServerCertificateValidationCallback = RemoteCertValidation;

            labelServiceStatus.Text = "";

            groupUsers.Enabled = false;
            groupProfiles.Enabled = false;

            originalTitle = Text;
            cmbJobStatusFilter.SelectedIndex = 0;
        }
        private void SaveURLUserPassword() {
            Microsoft.Win32.Registry.SetValue(@"HKEY_CURRENT_USER\MAY Computer\FileConverterPro\WebServiceSample", "URL", txtServiceUrl.Text);
            Microsoft.Win32.Registry.SetValue(@"HKEY_CURRENT_USER\MAY Computer\FileConverterPro\WebServiceSample", "AdminURL", txtAdminUrl.Text);
            Microsoft.Win32.Registry.SetValue(@"HKEY_CURRENT_USER\MAY Computer\FileConverterPro\WebServiceSample", "User", txtUserName.Text);
            Microsoft.Win32.Registry.SetValue(@"HKEY_CURRENT_USER\MAY Computer\FileConverterPro\WebServiceSample", "Password", txtPassword.Text);
        }
        private void LoadURLUserPassword() {
#if CUSTOM
            
#endif
            string s = Microsoft.Win32.Registry.GetValue(@"HKEY_CURRENT_USER\MAY Computer\FileConverterPro\WebServiceSample", "URL", txtServiceUrl.Text) as string;
            if (!string.IsNullOrEmpty(s))
                txtServiceUrl.Text = s;
            s = Microsoft.Win32.Registry.GetValue(@"HKEY_CURRENT_USER\MAY Computer\FileConverterPro\WebServiceSample", "AdminURL", txtAdminUrl.Text) as string;
            if (!string.IsNullOrEmpty(s))
                txtAdminUrl.Text = s;

            s = Microsoft.Win32.Registry.GetValue(@"HKEY_CURRENT_USER\MAY Computer\FileConverterPro\WebServiceSample", "User", txtUserName.Text) as string;
            if (!string.IsNullOrEmpty(s))
                txtUserName.Text = s;
            s = Microsoft.Win32.Registry.GetValue(@"HKEY_CURRENT_USER\MAY Computer\FileConverterPro\WebServiceSample", "Password", txtPassword.Text) as string;
            if (!string.IsNullOrEmpty(s))
                txtPassword.Text = s;
        }
        static bool RemoteCertValidation(object sender, X509Certificate certificate, X509Chain chain, SslPolicyErrors sslPolicyErrors) {
            return true;
        }
        private void InitClient(string userName, string password) {
            try {
                if (client == null) {
                    string configurationName = "basicHttpBindingSSL_IFileConverterProService2";
                    bool SSL = true;
                    if (string.IsNullOrEmpty(userName) && string.IsNullOrEmpty(password)) {
                        configurationName = "basicHttpBinding_IAutoOCRService2";
                        SSL = false;
                    }

                    client = new FileConverterProWebServiceSample.ServiceReference1.FileConverterProService2Client(configurationName);
                    client.Endpoint.Address =
                        new System.ServiceModel.EndpointAddress(txtServiceUrl.Text);

                    if (SSL) {
                        client.ClientCredentials.UserName.UserName = userName;
                        client.ClientCredentials.UserName.Password = password;
                    }
                }
            }
            catch(Exception ex) {
                client = null;

                MessageBox.Show("Initclient:" + ex.Message + "\r\n" + ex.StackTrace);
            }
        }
        private void InitAdmin(string userName, string password) {
            try {
                if (admin == null) {
                    string configurationName = "basicHttpBindingSSL_IFileConverterProAdmin2";
                    bool SSL = true;
                    if (string.IsNullOrEmpty(userName) && string.IsNullOrEmpty(password)) {
                        configurationName = "basicHttpBindingSSL_IFileConverterProAdmin2";
                        SSL = false;
                    }

                    admin = new FileConverterProWebServiceSample.ServiceReference2.FileConverterProAdmin2Client(configurationName);
                    admin.Endpoint.Address =
                        new System.ServiceModel.EndpointAddress(txtAdminUrl.Text);

                    if (SSL) {
                        admin.ClientCredentials.UserName.UserName = userName;
                        admin.ClientCredentials.UserName.Password = password;
                    }

                    btnStart.Enabled = btnStop.Enabled = btnGetStatus.Enabled = true;
                }
            }
            catch (Exception ex) {
                admin = null;

                MessageBox.Show("Initadmin:" + ex.Message + "\r\n" + ex.StackTrace);
            }
        }
        private void EnableControls(bool enable) {
            labelWebServiceSettings.Enabled = enable;
            cmbSettings.Enabled = enable;
            btnStats.Enabled = enable;
            gridJobs.Enabled = enable;
            labelDropTarget.Enabled = enable;
            labelMaxPages.Enabled = enable;
            updMaxPages.Enabled = enable;
            btnCancelJob.Enabled = enable;
            cmbJobStatusFilter.Enabled = enable;
            dgJobs2.Enabled = enable;
            btnCancel2.Enabled = enable;
            btnServerInfo.Enabled = enable;
            btnDeleteJob.Enabled = enable;
            btnDeleteAllJobs.Enabled = enable;
            groupFilter.Enabled = enable;
        }
        protected override void OnLoad(EventArgs e) {
            base.OnLoad(e);

            chkDateCreatedFilter_CheckedChanged(null, null);
            chkDateConvertedFilter_CheckedChanged(null, null);

            EnableControls(false);
            timerRefresh.Start();
            timerParalellUploads.Start();

            LoadURLUserPassword();

            System.Threading.Thread th = new System.Threading.Thread(UpdateJobStatusThread);
            th.IsBackground = true;
            th.Start(null);
        }
        protected override void OnClosed(EventArgs e) {
            base.OnClosed(e);
            SaveURLUserPassword();
        }
        private void button1_Click(object sender, EventArgs e) {
            try {
                if (client == null) return;

                int frAvailablePages = client.GetAvailablePages();
                int pagesInQueue = client.GetNrOfPagesInQueue();
                int docsInQueue = client.GetNrOfDocumentsInQueue();
                int pagesPerSec = client.GetAvgSecPerPage();

                string message = string.Format("Available pages: {0}\r\nPages in queue: {1}\r\nDocuments in queue:{2}\r\nAvg. seconds per page:{3}",
                    frAvailablePages,
                    pagesInQueue,
                    docsInQueue,
                    pagesPerSec);

                MessageBox.Show(message);
            }
            catch {
            }
        }
        private List<string> allowedExts = new List<string>(
             "DOC,DOCX,RTF,TXT,XLS,XLSX,PPT,PPTX,XFDF,FDF,PNG,ZIP,RAR,7Z,MSG,TIF,EML,PDF,PMT,BMP,JPG,HTM,HTML".ToLower().Split(',')
        );
        private void labelDropTarget_DragDrop(object sender, DragEventArgs e) {
            try {

                string[] files = null;
                if (e.Data != null && e.Data.GetDataPresent(DataFormats.FileDrop)) {
                    files = e.Data.GetData(DataFormats.FileDrop) as string[];

                    if (files != null && files.Length > 0) {
                        List<string> droppedFiles = new List<string>();
                        foreach (string file in files) {
                            string ext = System.IO.Path.GetExtension(file).ToLower().TrimStart('.');
                            if (allowedExts.Contains(ext))
                                droppedFiles.Add(file);
                        }

                        Timer aBitLater = new Timer() { Interval = 100, Tag = droppedFiles.ToArray() };
                        aBitLater.Tick += new EventHandler(aBitLater_Tick);
                        aBitLater.Start();
                    }
                }
            }
            catch {
            }
        }
        private string GetCurrentSettingsName() {
            try {
                if (cmbSettings.SelectedIndex >= 0) {
                    return engineSettings[cmbSettings.SelectedIndex].Name;
                }
                return "";
            }
            catch {
                return "";
            }
        }

        private delegate void AddJobSyncDelegate(FileConverterProWebServiceSample.ServiceReference1.JobResult jobResult);
        private void AddJobSync(FileConverterProWebServiceSample.ServiceReference1.JobResult jobResult) {
            gridJobs.Rows.Add(jobResult.JobGuid, jobResult.JobLabel, GetStatusDisplayName(jobResult.Status), "");
        }

        private void UploadJobAsync(object data) {
            IncrementUploadCounter();
            try {
                UploadJobData ujd = data as UploadJobData;
                FileConverterProWebServiceSample.ServiceReference1.JobResult jobResult =
                    client.UploadJobEx3(ujd.Ext, ujd.SettingsName, ujd.MaxPages, ujd.AdditionalOutput, ujd.Label, System.IO.File.ReadAllBytes(ujd.FilePath));
                if (!string.IsNullOrEmpty(jobResult.JobGuid) && jobResult.PageCount > 0) {
                    AddJobSyncDelegate del = new AddJobSyncDelegate(AddJobSync);
                    Invoke(del, jobResult);
                }
            }
            catch {
            }
            finally {
                DecrementUploadCounter();
            }
        }
        class UploadJobData {
            public string Ext { get; set; }
            public string SettingsName { get; set; }
            public int MaxPages { get; set; }
            public string AdditionalOutput { get; set; }
            public string Label { get; set; }
            public string FilePath { get; set; }

            public UploadJobData() {
                Ext = "";
                SettingsName = "";
                AdditionalOutput = "";
            }
        }
        private static int _uploadCounter = 0;
        private static void IncrementUploadCounter() {
            System.Threading.Interlocked.Increment(ref _uploadCounter);
        }
        private static void DecrementUploadCounter() {
            System.Threading.Interlocked.Decrement(ref _uploadCounter);
        }

        private delegate string[] GetJobGuidsSyncDelegate();
        private string[] GetJobGuidsSync() {
            List<string> result = new List<string>();
            foreach (DataGridViewRow r in gridJobs.Rows) {
                result.Add((string)r.Cells[0].Value);
            }
            return result.ToArray();
        }
        class JobStatusData {
            public string Status { get; set; }
            public string Error { get; set; }
        }
        private delegate void UpdateJobStatusSyncDelegate(Dictionary<string, JobStatusData> dict);
        private void UpdateJobStatusSync(Dictionary<string, JobStatusData> dict) {
            foreach (DataGridViewRow r in gridJobs.Rows) {
                string guid = (string)r.Cells[0].Value;
                JobStatusData status;
                if (dict.TryGetValue(guid, out status)) {
                    r.Cells[3].Value = status.Error;
                    r.Cells[2].Value = status.Status;
                }
            }
        }
        private void UpdateJobStatusThread(object data) {
            while (true) {
                try {
                    GetJobGuidsSyncDelegate getJobGuids = new GetJobGuidsSyncDelegate(GetJobGuidsSync);
                    string[] guids = Invoke(getJobGuids) as string[];

                    Dictionary<string, JobStatusData> dict = new Dictionary<string, JobStatusData>();
                    foreach (string guid in guids) {
                        if (client == null) continue;
                        int status = client.GetStatus(guid);
                        JobStatusData jsd = new JobStatusData();
                        jsd.Status = GetStatusDisplayName(status);
                        
                        if (status == 4) {
                            jsd.Error = "Download";
                        }
                        else {
                            jsd.Error = client.GetJob(guid).Errors;
                        }

                        dict[guid] = jsd;

                        UpdateJobStatusSyncDelegate updJobStatus = new UpdateJobStatusSyncDelegate(UpdateJobStatusSync);
                        Invoke(updJobStatus, dict);
                    }
                }
                catch {
                }
                System.Threading.Thread.Sleep(500);
            }
        }
        

        private void aBitLater_Tick(object sender, EventArgs e) {
            Timer timer = sender as Timer;
            try {
                timer.Stop();

                if (client != null) {
                    string[] files = timer.Tag as string[];

                    int maxPages = (int)updMaxPages.Value;
                    bool multiple = files.Length > 1;
                    foreach (string file in files) {
                        string label = multiple ? System.IO.Path.GetFileName(file) : LabelForm.AskLabel(System.IO.Path.GetFileName(file));
                        string ext = System.IO.Path.GetExtension(file).ToLower().TrimStart('.');


                        UploadJobData ujd = new UploadJobData() {
                            Ext = ext,
                            SettingsName = GetCurrentSettingsName(),
                            MaxPages = maxPages,
                            Label = label,
                            FilePath = file
                        };

                        //System.Threading.ThreadPool.QueueUserWorkItem(new System.Threading.WaitCallback(UploadJobAsync), ujd);
                        System.Threading.Thread th = new System.Threading.Thread(new System.Threading.ParameterizedThreadStart(UploadJobAsync));
                        th.IsBackground = true;
                        th.Start(ujd);

                        /*
                        ServiceReference1.JobResult jobResult =
                            client.UploadJobEx3(ext, GetCurrentSettingsName(), maxPages, additionalOutputs, label, System.IO.File.ReadAllBytes(file));
                        if (!string.IsNullOrEmpty(jobResult.JobGuid) && jobResult.PageCount > 0) {
                            gridJobs.Rows.Add(jobResult.JobGuid, jobResult.JobLabel, GetStatusDisplayName(jobResult.Status), "");
                        }*/
                    }
                }

            }
            catch { }
            finally {
                if (timer != null)
                    timer.Dispose();
            }
        }
        private void labelDropTarget_DragEnter(object sender, DragEventArgs e) {
            ProcessDrag(e);
        }
        private void labelDropTarget_DragLeave(object sender, EventArgs e) {
        }
        private void labelDropTarget_DragOver(object sender, DragEventArgs e) {
            ProcessDrag(e);
        }
        private void ProcessDrag(DragEventArgs e) {
            
            if (e.Data != null && e.Data.GetDataPresent(DataFormats.FileDrop)) {
                e.Effect = DragDropEffects.All;
            }
            else e.Effect = DragDropEffects.None;
        }
        private string GetStatusDisplayName(int status) {
            switch(status) { 
                case 1: return "Created";
                case 2: return "Uploaded";
                case 3: return "Converting";
                case 4: return "Converted"; 
                case 5: return "Downloaded";
                case 6: return "Error";
                case 7: return "Expired";
                case 8: return "Cancelled";
                default: return "Unknown";
            }
        }
        private void timerRefresh_Tick(object sender, EventArgs e) {

        }
        private void gridJobs_CellContentClick(object sender, DataGridViewCellEventArgs e) {
            try {
                if (e.ColumnIndex != 3) return;

                if (client != null) {
                    string jobID = gridJobs.Rows[e.RowIndex].Cells[0].Value.ToString();

                    for (int i = 0; i < client.GetResultCount(jobID); i++) {
                        string ext = client.GetResultExt(jobID, i);
                        ext = ext.Trim().Trim('.').Trim();


                        byte[] data = client.DownloadResult(jobID, i, false);

                        string path = System.IO.Path.GetTempPath();
                        path = System.IO.Path.Combine(path, jobID + "." + ext);
                        System.IO.File.WriteAllBytes(path, data);

                        //System.Diagnostics.Process.Start("acrord32.exe", path);
                        try {
                            SaveLocalPath(path);
                            System.Diagnostics.Process.Start(path);
                        }
                        catch { }
                    }
                }
            }
            catch {
            }
        }
        private List<FileConverterProWebServiceSample.ServiceReference1.EngineSettings> engineSettings = new List<FileConverterProWebServiceSample.ServiceReference1.EngineSettings>();
        private void btnConnect_Click(object sender, EventArgs e) {
            string userName = "", password = "";
            if (txtServiceUrl.Text.ToLower().StartsWith("https://")) {
                userName = txtUserName.Text;
                password = txtPassword.Text;
            }


            client = null;
            InitClient(userName, password);

            cmbSettings.Items.Clear();
            engineSettings.Clear();

            try {
                if (client == null) {
                    MessageBox.Show("Client == null");
                    return;
                }

                foreach (FileConverterProWebServiceSample.ServiceReference1.EngineSettings settings in client.GetSettingsCollection()) {
                    if (settings == null) {
                        MessageBox.Show("settings==null");
                        return;
                    }
                    string name = settings.Name;
                    if (!string.IsNullOrEmpty(settings.Description))
                        name += "(" + settings.Description + ")";
                    cmbSettings.Items.Add(name);
                    engineSettings.Add(settings);
                }
                if (cmbSettings.Items.Count > 0) cmbSettings.SelectedIndex = 0;

                EnableControls(true);

                Text = originalTitle + " - Server version: " + client.GetServerVersion();

          }
            catch (Exception ex) {
                EnableControls(false);
                client = null;
                MessageBox.Show("Failed to connect to the service!" + "\r\n" + ex.Message, Text);
                Text = originalTitle;
            }

            cmbSettings_SelectedIndexChanged(cmbSettings, EventArgs.Empty);

        }
        private void cmbSettings_SelectedIndexChanged(object sender, EventArgs e) {
        }
        private string RightsToStr(int rights) {
            string result = "";

            foreach (WCFUserRights r in Enum.GetValues(typeof(WCFUserRights))) {
                if (r == WCFUserRights.None) continue;
                if ((r & ((WCFUserRights)rights)) == r) {
                    result += r.ToString() + ",";
                }
                else result += "-,";
            }
            return result.TrimEnd(',');
        }
        private void ReadAllUsers() {
            gridUsers.Rows.Clear();
            if (admin == null) return;

            try {
                foreach (FileConverterProWebServiceSample.ServiceReference2.WebServiceUser wcfUser in admin.GetUsers()) {
                    int index = gridUsers.Rows.Add(wcfUser.UserName, RightsToStr(wcfUser.Rights));
                    gridUsers.Rows[index].Tag = wcfUser;
                }
            }
            catch (Exception ex) {
                MessageBox.Show(ex.Message, Text);
                gridUsers.Rows.Clear();
            }
        }
        private void ReadAllProfiles() {
            try {
                gridProfiles.Rows.Clear();
                foreach (FileConverterProWebServiceSample.ServiceReference2.EngineSettings setting in admin.GetProfiles()) {
                    int index = gridProfiles.Rows.Add(setting.Name,
                        setting.Name,
                        setting.Description);
                    gridProfiles.Rows[index].Tag = setting;
                }
            }
            catch (Exception) {
            }
        }
        private void btnAdminConnect_Click(object sender, EventArgs e) {
            string userName = "", password = "";
            if (txtAdminUrl.Text.ToLower().StartsWith("https://")) {
                userName = txtUserName.Text;
                password = txtPassword.Text;
            }

            admin = null;
            InitAdmin(userName, password);

            groupUsers.Enabled = admin != null;
            groupProfiles.Enabled = admin != null;

            ReadAllUsers();
            ReadAllProfiles();

            gridProfiles_SelectionChanged(gridProfiles, EventArgs.Empty);
            gridUsers_SelectionChanged(gridUsers, EventArgs.Empty);

        }
        private void btnStart_Click(object sender, EventArgs e) {
            try {
                if (admin != null) {
                    if (!admin.IsStarted()) {
                        admin.Start();
                    }
                    else {
                        MessageBox.Show("The service is already started!", Text);
                    }
                }
            }
            catch (Exception ex) {
                MessageBox.Show("Failed to start the processing!\r\n" + ex.Message, Text);
            }
        }
        private void btnStop_Click(object sender, EventArgs e) {
            try {
                if (admin != null) {
                    if (admin.IsStarted()) {
                        admin.Stop();
                    }
                    else {
                        MessageBox.Show("The service is not started!", Text);
                    }
                }
            }
            catch (Exception ex) {
                MessageBox.Show("Failed to stop the processing!\r\n" + ex.Message, Text);
            }
        }
        private void btnGetStatus_Click(object sender, EventArgs e) {
            try {
                labelServiceStatus.Text = admin.IsStarted() ? "Started" : "Stopped";
            }
            catch (Exception ex) {
                labelServiceStatus.Text = "Unknown";
                MessageBox.Show("Failed to get the service status!\r\n" +ex.Message, Text);
            }
        }
        private void btnGetFormats_Click(object sender, EventArgs e) {
            
        }
        private void gridUsers_SelectionChanged(object sender, EventArgs e) {
            bool selection = gridUsers.SelectedRows.Count > 0;
            btnEditUser.Enabled = selection;
            btnDeleteUser.Enabled = selection;

        }
        private void btnNewUser_Click(object sender, EventArgs e) {
            try {
                UserForm frm = new UserForm();
                if (frm.ShowDialog() != DialogResult.OK) return;

                if (!admin.AddUser(frm.UserName, frm.Password, (int)frm.Rights)) {
                    MessageBox.Show("Failed to add user!");
                }
            }
            catch (Exception ex) {
                MessageBox.Show("Failed to add user!" + ex.Message);
            }

            ReadAllUsers();
        }
        private void btnEditUser_Click(object sender, EventArgs e) {
            try {
                if (gridUsers.SelectedRows.Count == 0) return;
                FileConverterProWebServiceSample.ServiceReference2.WebServiceUser user = gridUsers.SelectedRows[0].Tag as FileConverterProWebServiceSample.ServiceReference2.WebServiceUser;

                UserForm frm = new UserForm();
                frm.UserName = user.UserName;
                frm.Rights = (WCFUserRights)user.Rights;

                if (frm.ShowDialog() != DialogResult.OK) return;

                if (frm.PasswordChanged) {
                    if (!admin.ChangeUserPassword(frm.UserName, frm.Password)) {
                        MessageBox.Show("Failed to change the password");
                        return;
                    }
                }
                if (!admin.ModifyUserRights(frm.UserName, (int)frm.Rights)) {
                    MessageBox.Show("Failed to change the user's rights");
                    return;
                }

                user.Rights = (int)frm.Rights;
                gridUsers.SelectedRows[0].Cells["colRights"].Value = RightsToStr((int)frm.Rights);
            }
            catch (Exception ex) {
                MessageBox.Show("Failed to modify the user!" + ex.Message);
            }
        }
        private void btnDeleteUser_Click(object sender, EventArgs e) {
            try {
                if (gridUsers.SelectedRows.Count == 0) return;
                FileConverterProWebServiceSample.ServiceReference2.WebServiceUser user = gridUsers.SelectedRows[0].Tag as FileConverterProWebServiceSample.ServiceReference2.WebServiceUser;

                if (!admin.DeleteUser(user.UserName)) {
                    MessageBox.Show("Failed to delete the user!");
                    return;
                }
                gridUsers.Rows.Remove(gridUsers.SelectedRows[0]);
            }
            catch (Exception ex) {
                MessageBox.Show("Failed to delete the user!" + ex.Message);
            }
        }
        private void gridProfiles_SelectionChanged(object sender, EventArgs e) {
            bool selection = gridProfiles.SelectedRows.Count > 0;
            btnEditProfile.Enabled = selection;
            btnDeleteProfile.Enabled = selection;
        }
        private string SelectFile(bool save) {
            if (save) {
                SaveFileDialog sfd = new SaveFileDialog() {
                    Filter = "FileConverterPro Profiles (*.fcprox)|*.fcprox",
                };
                if (sfd.ShowDialog() != DialogResult.OK)
                    return "";
                return sfd.FileNames[0];
            }
            else {
                OpenFileDialog ofd = new OpenFileDialog() {
                    Multiselect = false,
                    Filter = "FileConverter Profiles (*.fcprox)|*.fcprox",
                };
                if (ofd.ShowDialog() != DialogResult.OK)
                    return "";
                return ofd.FileNames[0];
            }
        }
        private string ReadXml(string file) {
            System.Xml.XmlDocument doc = new System.Xml.XmlDocument();
            doc.Load(file);
            return doc.OuterXml;
        }
        private void WriteXml(string file, string content) {
            System.Xml.XmlDocument doc = new System.Xml.XmlDocument();
            doc.LoadXml(content);
            doc.Save(file);
        }
        private void btnNewProfile_Click(object sender, EventArgs e) {
            string file = SelectFile(false);
            if (string.IsNullOrEmpty(file)) return;

            try {
                string profileName =
                    System.IO.Path.GetFileNameWithoutExtension(file);

                if (!admin.UploadProfile(profileName, ReadXml(file))) {
                    MessageBox.Show("Failed to upload the OCR profile!");
                }

                ReadAllProfiles();
            }
            catch(Exception ex) {
                MessageBox.Show("Failed to upload the OCR profile!", ex.Message);
            }
        }
        private void btnEditProfile_Click(object sender, EventArgs e) {
            try {
                if (gridProfiles.SelectedRows.Count == 0) return;
                FileConverterProWebServiceSample.ServiceReference2.EngineSettings settings = gridProfiles.SelectedRows[0].Tag as FileConverterProWebServiceSample.ServiceReference2.EngineSettings;

                string file = SelectFile(false);
                if (string.IsNullOrEmpty(file)) return;

                if (!admin.UploadProfile(settings.Name, ReadXml(file))) {
                    MessageBox.Show("Failed to update/upload the OCR profile!");
                    return;
                }

                ReadAllProfiles();
            }
            catch (Exception ex) {
                MessageBox.Show("Failed to update/upload the OCR profile!" + ex.Message);
            }
        }
        private void btnDeleteProfile_Click(object sender, EventArgs e) {
            try {
                if (gridProfiles.SelectedRows.Count == 0) return;
                FileConverterProWebServiceSample.ServiceReference2.EngineSettings settings = gridProfiles.SelectedRows[0].Tag as FileConverterProWebServiceSample.ServiceReference2.EngineSettings;

                if (!admin.DeleteProfile(settings.Name)) {
                    MessageBox.Show("Failed to delete the OCR profile");
                    return;
                }

                ReadAllProfiles();
            }
            catch (Exception ex) {
                MessageBox.Show("Failed to delete the profile!" + ex.Message);
            }
        }
        private void btnDownloadProfile_Click(object sender, EventArgs e) {
            try {
                if (gridProfiles.SelectedRows.Count == 0) return;
                FileConverterProWebServiceSample.ServiceReference2.EngineSettings settings = gridProfiles.SelectedRows[0].Tag as FileConverterProWebServiceSample.ServiceReference2.EngineSettings;

                string file = SelectFile(true);
                if(string.IsNullOrEmpty(file)) return;

                string xml = admin.DownloadProfile(settings.Name);
                if (string.IsNullOrEmpty(xml)) {
                    MessageBox.Show("Failed to download the profile!");
                    return;
                }

                WriteXml(file, xml);

                if (MessageBox.Show("Do you want to open the profile?", "", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes) {
                    try {
                        System.Diagnostics.Process.Start(file);
                    }
                    catch {
                    }
                }
                
            }
            catch (Exception ex) {
                MessageBox.Show("Failed to download the profile!" + ex.Message);
            }
        }
        private void btnCancelJob_Click(object sender, EventArgs e) {
            try {
                if (gridJobs.SelectedRows.Count == 0) {
                    MessageBox.Show("Please select a job!", Text);
                    return;
                }

                string jobId = gridJobs.SelectedRows[0].Cells[0].Value as string;
                if (string.IsNullOrEmpty(jobId)) {
                    MessageBox.Show("Please select a job!", Text);
                }
                string cancelledJobId = client.CancelJob(jobId);
                if (cancelledJobId.ToLower() != jobId.ToLower()) {
                    MessageBox.Show("Failed to cancel the job!", Text);
                }
                else {
                    MessageBox.Show("The job was cancelled!", Text);
                }
            }
            catch (Exception ex) {
                MessageBox.Show("Failed to cancel the job!" + ex.Message, Text);
            }
        }
        private void FillJobs(FileConverterProWebServiceSample.ServiceReference1.JobResult[] jobs) {
            dgJobs2.Rows.Clear();

            foreach (FileConverterProWebServiceSample.ServiceReference1.JobResult job in jobs) {
                dgJobs2.Rows.Add(job.UserName,
                    job.CreationDate.ToString("yyyy/MM/dd HH:mm:ss", System.Globalization.CultureInfo.InvariantCulture),
                    job.FinishedDate.ToString("yyyy/MM/dd HH:mm:ss", System.Globalization.CultureInfo.InvariantCulture),
                    job.JobGuid,
                    job.JobLabel,
                    GetStatusDisplayName(job.Status),
                    job.Errors);

            }
        }
        private void GetJobs(bool all, int status) {
            try {
                FileConverterProWebServiceSample.ServiceReference1.JobResult[] jobs =
                    all ? client.GetAllJobs(status) : client.GetOwnJobs(status);
                dgJobs2.Rows.Clear();

                foreach (FileConverterProWebServiceSample.ServiceReference1.JobResult job in jobs) {
                    dgJobs2.Rows.Add(job.UserName,
                        job.CreationDate.ToString("yyyy/MM/dd HH:mm:ss", System.Globalization.CultureInfo.InvariantCulture),
                        job.FinishedDate.ToString("yyyy/MM/dd HH:mm:ss", System.Globalization.CultureInfo.InvariantCulture),
                        job.JobGuid,
                        job.JobLabel,
                        GetStatusDisplayName(job.Status),
                        job.Errors);

                }
            }
            catch (Exception ex) {
                MessageBox.Show("Error reading jobs!" + ex.Message, Text);
            }
        }
        private void btnCancel2_Click(object sender, EventArgs e) {
            try {
                if (dgJobs2.SelectedRows.Count == 0) {
                    MessageBox.Show("Please select a job!", Text);
                    return;
                }

                string guid = dgJobs2.SelectedRows[0].Cells[3].Value as string;
                string resultId = client.CancelJob(guid);
                if (guid.ToLower() != resultId.ToLower()) {
                    MessageBox.Show("Failed to cancel the job!", Text);
                }
                else {
                    MessageBox.Show("The job was cancelled!");

                    try {
                        FileConverterProWebServiceSample.ServiceReference1.JobResult job =
                            client.GetJob(resultId);
                        
                        dgJobs2.SelectedRows[0].Cells[5].Value = GetStatusDisplayName(job.Status);
                        dgJobs2.SelectedRows[0].Cells[6].Value = job.Errors;
                    }
                    catch {
                    }
                }
            }
            catch (Exception ex) {
                MessageBox.Show("Failed to cancel the job!" + ex.Message, Text);
            }
        }
        private void btnServerInfo_Click(object sender, EventArgs e) {
            try {
                string serverVersion = client.GetServerVersion();
                int serverHash = client.GetServerHash();

                string message = string.Format("Server information\r\n--------------------\r\nVersion: v{0}\r\nHash: {1}",
                    serverVersion,
                    serverHash);
                MessageBox.Show(message, Text);
            }
            catch (Exception ex) {
                MessageBox.Show("Failed to get the server info!" + ex.Message, Text);
            }
        }
        private void btnDeleteJob_Click(object sender, EventArgs e) {
            try {
                if (dgJobs2.SelectedRows.Count == 0) {
                    MessageBox.Show("Please select a job!", Text);
                    return;
                }

                string guid = dgJobs2.SelectedRows[0].Cells[3].Value as string;
                client.RemoveJob(guid);

                FileConverterProWebServiceSample.ServiceReference1.JobResult result = 
                    client.GetJob(guid);

                if (string.IsNullOrEmpty(result.JobGuid) || result.JobID == 0) {

                    MessageBox.Show("The job was removed!", Text);

                    dgJobs2.Rows.Remove(dgJobs2.SelectedRows[0]);
                }
                else {
                    MessageBox.Show("Failed to delete the job!", Text);
                }
            }
            catch (Exception ex) {
                MessageBox.Show("Failed to cancel the job!" + ex.Message, Text);
            }
        }

        private void timerParalellUploads_Tick(object sender, EventArgs e) {
            txtParalellUploads.Text = _uploadCounter.ToString();
        }

        private void btnDeleteAllJobs_Click(object sender, EventArgs e) {
            try {
                if (MessageBox.Show("Do you really want to delete all jobs?", Text, MessageBoxButtons.YesNo) != DialogResult.Yes)
                    return;
                int result = client.DeleteAllJobs();
                MessageBox.Show(string.Format("{0} jobs deleted.", result));
            }
            catch (Exception ex) {
                MessageBox.Show("Failed to delete all jobs!" + ex.Message, Text);
            }
        }

        private void chkDateCreatedFilter_CheckedChanged(object sender, EventArgs e) {
            dtDateCreatedFromFilter.Enabled = dtDateCreatedToFilter.Enabled = chkDateCreatedFilter.Checked;
        }

        private void chkDateConvertedFilter_CheckedChanged(object sender, EventArgs e) {
            dtDateConvertedFromFilter.Enabled =
                dtDateConvertedToFilter.Enabled = chkDateConvertedFilter.Checked;
        }

        int enumID = 0;
        private void btnFilter_Click(object sender, EventArgs e) {
            try {
                FileConverterProWebServiceSample.ServiceReference1.JobEnumFilter jef =
                    new FileConverterProWebServiceSample.ServiceReference1.JobEnumFilter();

                jef.PageSize = 5;
                jef.UserName = txtUserNameFilter.Text;
                jef.Label = txtJobLabelFilter.Text;
                jef.Status = cmbJobStatusFilter.SelectedIndex == 0 ? 100 : cmbJobStatusFilter.SelectedIndex;

                if (chkDateCreatedFilter.Checked) {
                    jef.DateCreated = new DateTime[] { dtDateCreatedFromFilter.Value, dtDateCreatedToFilter.Value };
                }
                else {
                    jef.DateCreated = new DateTime[] { };
                }

                if (chkDateConvertedFilter.Checked) {
                    jef.DateConverted = new DateTime[] { dtDateConvertedFromFilter.Value, dtDateConvertedToFilter.Value };
                }
                else {
                    jef.DateConverted = new DateTime[] { };
                }

                List<string> sortColumns = new List<string>();
                foreach (KeyValuePair<string, bool> kp in dictChecked) {
                    sortColumns.Add(kp.Key + (kp.Value ? "ASC" : "DESC"));
                }
                jef.SortColumns = sortColumns.ToArray();

                FileConverterProWebServiceSample.ServiceReference1.JobEnum je = client.EnumJobs(jef);
                txtTotalJobs.Text = je.TotalJobs.ToString();
                txtTotalPages.Text = je.PagesCount.ToString();
                enumID = je.JobEnumID;
                updCurrentPage.Value = 0;
                updCurrentPage.Maximum = je.PagesCount;
                if (je.PagesCount > 0) {
                    updCurrentPage.Value = 1;
                }

                if (je.TotalJobs == 0)
                    FillJobs(new FileConverterProWebServiceSample.ServiceReference1.JobResult[] { });
            }
            catch(Exception ex) {
                FillJobs(new FileConverterProWebServiceSample.ServiceReference1.JobResult[] { });
                MessageBox.Show(ex.Message);
            }
        }

        private void updCurrentPage_ValueChanged(object sender, EventArgs e) {
            try {
                if (enumID == 0 || updCurrentPage.Value == 0) {
                    FillJobs(new FileConverterProWebServiceSample.ServiceReference1.JobResult[] { });
                    return;
                }

                FileConverterProWebServiceSample.ServiceReference1.JobResult[] result =
                    client.EnumJobsGetPage(enumID, (int)updCurrentPage.Value);
                FillJobs(result);
            }
            catch {
                FillJobs(new FileConverterProWebServiceSample.ServiceReference1.JobResult[] { });
            }
        }


        private bool isChecking = false;
        private Dictionary<string, bool> dictChecked = new Dictionary<string, bool>();
        private void chkSortOrder_ItemCheck(object sender, ItemCheckEventArgs e) {
            if (isChecking) return;

            isChecking = true;
            try {
                string item = chkSortOrder.Items[e.Index] as string;
                string realItem = item.Replace("ASC", "").Replace("DESC", "").Trim();

                bool asc = item.EndsWith("ASC");

                if (e.NewValue == CheckState.Checked) {
                    dictChecked[realItem] = asc;

                    string otherItem = realItem;
                    if (asc)
                        otherItem += " DESC";
                    else otherItem += " ASC";

                    int index = chkSortOrder.FindStringExact(otherItem);
                    chkSortOrder.SetItemChecked(index, false);
                }
                else {
                    dictChecked.Remove(realItem);
                }
            }
            finally {
                isChecking = false;
            }
        }

        private void btnDirectConversion_Click(object sender, EventArgs e) {
            if (client == null) return;
            string filePath = "";
            string ext = "";
            string label = "";
            byte[] data = null;

            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = "All supported file formats|";
            foreach (string ae in allowedExts) {
                ofd.Filter += "*." + ae + ";";
            }
            ofd.Filter = ofd.Filter.TrimEnd(';');
            ofd.CheckFileExists = true;
            ofd.Multiselect = false;
            if (ofd.ShowDialog() != DialogResult.OK) return;

            filePath = ofd.FileNames[0];
            ext = System.IO.Path.GetExtension(filePath).TrimStart('.');
            label = System.IO.Path.GetFileName(filePath);
            data = System.IO.File.ReadAllBytes(filePath);

            client.BeginUploadJobEx4(ext,
                GetCurrentSettingsName(),
                -1,
                "pdf",
                label,
                data,
                new AsyncCallback(Callback),
                null);
        }
        public void Callback(IAsyncResult result) {
       
            FileConverterProWebServiceSample.ServiceReference1.JobResult res = 
                client.EndUploadJobEx4(result);

            if (res.PdfData != null && res.PdfData.Length > 0) {
                string path = System.IO.Path.GetTempPath();
                path = System.IO.Path.Combine(path, res.JobGuid + ".pdf");
                System.IO.File.WriteAllBytes(path, res.PdfData);

                try {
                    SaveLocalPath(path);
                    System.Diagnostics.Process.Start(path);
                }
                catch { }
            }
            else {
                MessageBox.Show("Conversion failed." + res.Errors);
            }
        }
    }

    [Flags]
    public enum WCFUserRights : int {
        None = 0,
        Connect = 1,
        GetListOfOwnJobs = 2,
        GetListOfAllJobs = 4,
        AllowStartStop = 8,
        AllowManageUsers = 16,
        AllowManagerProfiles = 32,
        AllowManageJobs = 64
    }
}
